<?php
/**
 * archive.php - to keep goal in archive state.
 *
 * @author $Author: wichai $
 * @version $Id: archive.php,v 1.2 2011/10/19 04:13:26 wichai Exp $
 * @copyright Copyright (c) 2011, Tiller Software Co., Ltd.
*/

class Archive extends CI_Controller{
	private $empty_history;

	function __construct(){
		parent::__construct();
		$this->load->library('goal/goal_common');
		// only goal system admin to use this controller
		if ( !$this->goal_common->is_goal_system_admin() ){
			echo osa_ajaxmsg(lang('gen_no_permission_ajaxmsg'));
			exit;
		}
		$this->load->model('goal/goal_model');
		$this->load->library('cms/Cms_syslog');
		osa_load_lang('goal');
	}

	function index($view_data = FALSE){
		if ( !is_object($view_data) ){
			$view_data = $this->_view_datastructure();
		}
		// If no enabled evaluation, no need to enable this function
		if ( !$this->_has_enabled_evaluation() ){
			$view_data->disable_archive_function = TRUE;
			// Normally, no enabled evaluation will show no active evaluations message
			// but if has progress text while archiving, the message will not show
			if ( !$view_data->progress ){
				$view_data->show_no_active_evaluations = TRUE;
			}
		}
		$view_data->history = $this->_get_archived_log();
		if ( $this->empty_history ){
			$view_data->show_empty_history = TRUE;
		}
		$this->load->view('goal/goal_archive_view', $view_data);
	}

	function update(){
		$view_data = $this->_view_datastructure();
		// check enabled evaluation before archive to ensure
		// this can be happend when users archive in same time
		if ( $this->_has_enabled_evaluation() && $this->goal_model->archive_all() ){
			$view_data->progress = lang('goal_archive_done');
			// write log
			$this->cms_syslog->write(cms_syslog::TYPE_EVALUATION_ARCHIVE, lang('goal_archive_done'));
		}
		else {
			$view_data->progress = lang('goal_archive_fail');
		}
		$this->index($view_data);
	}

	private function _get_archived_log(){
		$log_data = $this->cms_syslog->get(cms_syslog::TYPE_EVALUATION_ARCHIVE);
		if ( empty($log_data) ){
			// assign empty array to display empty table
			$log_data = array();
			$this->empty_history = TRUE;
		}
		return $this->cms_syslog->print_table($log_data, FALSE, TRUE, TRUE, TRUE);
	}

	private function _has_enabled_evaluation(){
		if ( $this->goal_model->get_numrows_enabled() ) {
			return TRUE;
		}
		return FALSE;
	}

	private function _view_datastructure(){
		$view_data = new stdClass();
		$view_data->disable_archive_function = FALSE;
		$view_data->progress = FALSE;
		$view_data->history = FALSE;
		$view_data->show_no_active_evaluations = FALSE;
		$view_data->show_empty_history = FALSE;
		return $view_data;
	}

}