<?php
/**
 * search.php
 *
 * The main search controller. All mapping searches will come here.
 * This controller figures out which search object to call and passes the proper params.
 *
 * @author $Author: dtong $
 * @version $Id: search.php,v 1.8 2011/11/24 06:26:12 dtong Exp $
 * @copyright Copyright (c) 2009, Tiller Software Co., Ltd.
*/

class Search extends CI_Controller{
	function __construct() {
		parent::__construct();
		osa_nosession_ajax_redirect();
		osa_check_access('mapping', TRUE);
	}

	/*
	 * This uses dynamic library loading to handle the search.
	 * The dynamic library is designed to support saved searches.
	 * Save $_REQUEST and the library name in the DB and you can perform the same search again.
	 *
	 * The $flag_session and searchsort_model were bad code and need to be rewritten.
	 * These are for the standbench multi-format search result window.
	 */
	function get($handle, $searchid, $flag_session=FALSE ) {
		/*
		$this->CI = get_instance();
		$this->CI->load->model('sort/searchsort_model');
		$sql_array = $this->CI->searchsort_model->getSqlSession('map_' . $handle);
		$sql_array['type'] = $flag_session;
		$this->CI->searchsort_model->setSqlSession('map_' . $handle, $sql_array);
		*/
		$lib = "mapping/Handle_{$handle}";
		$obj = "handle_{$handle}";
		if ( osa_lib_exists($lib) ) {
			$this->load->library($lib, array('request'=>$_REQUEST, 'searchid'=>$searchid));
		}
		elseif ( osa_3p_available() ) {
			// Load 3rd party search obejct if there is one.
			$this->cms_3p->load_lib($obj, CMS_3P_FOLDER_MAPPING, array('request'=>$_REQUEST, 'searchid'=>$searchid));
		}
		if ( !property_exists($this, $obj) ) {
			// Couldn't load the object so error out.
			osa_errorlog(__METHOD__ . " - Invalid search handle $handle");
			echo osa_ajaxmsg(lang('gen_internalservererror'));
			exit;
		}
		$this->$obj->process();
	}

	function normal($handle, $searchid) {
		$this->get($handle, $searchid, CMS_MAPPING_NORMAL);
	}

	function course($handle, $searchid) {
		$this->get($handle, $searchid, CMS_MAPPING_COURSE);
	}

	function grade($handle, $searchid) {
		$this->get($handle, $searchid, CMS_MAPPING_GRADE);
	}
}
?>