<?php
/**
 * cms_maintenance_check - check about maintenance mode
 *
 * @author $Author: dtong $
 * @version $Id: Cms_maintenance_check.php,v 1.6 2012/05/04 10:56:56 dtong Exp $
 * @copyright Copyright (c) 2011, Tiller Software Co., Ltd.
*/

class Cms_maintenance_check {

	private $CI=NULL;

	function __construct() {
		$this->CI =& get_instance();
	}

	function is_passthrough(){
		if ( empty($_POST['password']) ) {
			return FALSE;
		}
		if ( !$this->CI->config->item('cms_magic_password') ) {
			return FALSE;
		}
		$post_password = osa_des_decrypt($_POST['password']);
		if ( !$post_password ) {
			return FALSE;
		}
		require_once(APPPATH . 'models/auth/auth_factory.php');
		// require_once(APPPATH . 'models/auth/auth_local.php');
		$auth_local = auth_factory::factory('local');
		if ( empty($auth_local) ) {
			return FALSE;
		}
		if ( ($auth_local->authenticate('', $post_password, FALSE)) ) {
			// Check for magic password.
			return TRUE;
		}
		return FALSE;
	}

}