<?php
/**
 * syslog_model - Model for system log
 *
 * @author $Author: dtong $
 * @version $Id: syslog_model.php,v 1.2 2011/09/12 09:30:44 dtong Exp $
 * @copyright Copyright (c) 2011, Tiller Software Co., Ltd.
*/

class Syslog_model extends CI_Model {
	//Will need to add interface to do paging later.
	//Just get up to a thousand records for now.
	private $query_limit = 1000;
	private $query_offset = 0;

	//Inserts one log entry
	function insert($type, $text, $userid, $username=NULL, $fk1=NULL) {
		$data = new stdClass();
		$data->type = $type;
		$data->text = $text;
		$data->userid = $userid;
		$data->username = $username;
		$data->fk1 = $fk1;
		$data->createdate = osa_dbdate();
		return $this->db->insert('syslog', $data);
	}

	function get($type, $userid=FALSE) {
		if ( !osa_is_int($type) ) {
			return FALSE;
		}
		return $this->_get($type, $userid);
	}

	function get_by_userid($userid, $type=FALSE) {
		if ( !osa_is_int($userid) ) {
			return FALSE;
		}
		return $this->_get($type, $userid);
	}

	//The actual get function
	private function _get($type=FALSE, $userid=FALSE) {
		$this->db->select('s.*,u.firstname,u.lastname,u.middlename,u.displayname');
		$this->db->from('syslog s');
		$this->db->join('user u', 's.userid=u.id', 'left');
		if ( $type !== FALSE && osa_is_int($type) ) {
			$this->db->where('s.type', $type);
		}
		if ( $userid && osa_is_int($userid) ) {
			$this->db->where('s.userid', $userid);
		}
		$this->db->limit($this->query_limit, $this->query_offset);
		$res = $this->db->get();

		if ( $res->num_rows() <= 0 ) {
			return FALSE;
		}
		return $res->result();
	}

}