<?php
/**
 * all_jscript_view.php
 *
 * Include all jscripts and our css file. Always use this file instead of including in your own PHP file.
 * DO NOT ADD MORE CASE STATEMENTS since it is most likely not necessary. The various types of include should work
 * for all needs. Always use echo if you need to load another view in this view file.
 *
 * DO NOT CHANGE EXISTINHG INCLUDE ORDER. This can break some javascript code.
 *
 * To use this view, pass a view variable $type with one of the following:
 *
 * 	'login' - For the login pages (site and survey).
 * 	'pdf' - For the PDF generator without Javascript on the page.
 * 	'read' - For html and rignt now, this is same as PDF. For readonly with just the css file.
 * 	'pdfjs' - For the PDF generator with Javascript (TinyMCE math images) on the page.
 * 	'readjs' - For read only html but we still need math and dhtml jscripts in addition to app.js and sys.js.
 * 	'plain' - Everything except without any external Javascript libraries such as calendar, jstree,
 * 				 but dhtmlxwindow and jquery are included to support app.js and sys.js.
 * 				 This is used on the survey page where users take the surveys and dbupgrade etc.
 * 				 Iframe and new window should use this or the "full" type.
 * 	'home' - This includes everything for the home page. You can skip the $type variable
 * 				since this is the default if a type is not supplied.
 * 	'upload' - This is for the popup window from the template engine. This has the plupload,
 * 				  tinymce and everything else. You need to pass 'upload_queuelist_height'=>INTEGER to include
 * 				  plupload related files and 'tinymce'=>true to include tinymce related files.
 * 				  Pass false or ignore to skip these includes.
 *
 * 	Note: The jscript_globalvars_view has to be loaded between third-party jscripts and our jscripts.
 * 			Not following this rule can cause jscript errors.
 * 			Doing a break or return in a new case statement makes a huge difference. If you are not sure what this means
 * 			then you should not edit this file at all.
 *
 * @author $Author: dtong $
 * @version $Id: all_jscript_view.php,v 1.22 2012/02/06 04:15:03 dtong Exp $
 * @copyright Copyright (c) 2009, Tiller Software Co., Ltd.
*/
	// Used to need this to hide the TinyMCE math obj but it went away. May be a recent upgrade fixed it.
	// $hide_math_obj = '<script type="text/javascript">hiddenOBJ();</script>';
	if ( !isset($type) || !$type ) {
		$type = 'home';
	}

	$include_path = osa_include_path();

	// All jscript and css file literals should not appear more than once in this file.
	// This is strictly enforced!
	// You have to make sure jquery always get loaded first byt the browser.
	$jquery_jscript = "<script type=\"text/javascript\" src=\"{$include_path}js/jstree/lib/jquery.js\"></script>";
	$calendar_cssfile = "<link rel=\"stylesheet\" href=\"{$include_path}js/calendar/calendar-win2k-1.css\" type=\"text/css\" media=\"screen\" />";
	$math_jscripts = "<script type=\"text/javascript\" src=\"{$include_path}js/tiny_mce/plugins/asciimath/js/ASCIIMathMLwFallback.js\"></script>" .
						  "<script type=\"text/javascript\" src=\"{$include_path}js/tiny_mce/plugins/asciisvg/js/ASCIIsvgPI.js\"></script>";
	// Add new jscripts right above this line.

	// TODO: calendar is hardcoded with english: calendar-en.js. Need to make it flexible.
	// Always load the jscripts in order of importance and then usage frequency.
	// Our own jscripts always come last.
	$home_jscritps = $jquery_jscript .
		"<script type='text/javascript' src='{$include_path}js/jstree/lib/jquery.cookie.js'></script>" .
		"<script type='text/javascript' src='{$include_path}js/jstree/jquery.jstree.js'></script>" .
		$this->load->view('template/dhtmlxwindows_js_view', array(), TRUE) .
		"<script type='text/javascript' src='{$include_path}js/calendar/calendar_stripped.js'></script>" .
		"<script type='text/javascript' src='{$include_path}js/calendar/lang/calendar-en.js'></script>" .
		"<script type='text/javascript' src='{$include_path}js/calendar/calendar-setup_stripped.js'></script>" .
		"<script type='text/javascript' src='{$include_path}js/flashchart/swfobject.js'></script>" .
		$math_jscripts .
		"<script type='text/javascript' src='{$include_path}js/des.js'></script>";

	//////////////////////////// Output starts from here on //////////////////////////////

	// Always include our CSS files.
	osa_appcss_include();

	switch ($type) {
		case 'login' :
//////////////////////////// Begin login //////////////////////////////
echo $jquery_jscript ?>
<script type="text/javascript" src="<?php echo $include_path?>js/des.js"></script>
<script type="text/javascript" src="<?php echo $include_path?>js/sys.js"></script><?php

			echo $this->load->view('template/jscript_globalvars_view', array(), TRUE);
			return;
// ----------------- End login ----------------------

		case 'pdf' :
		case 'read' :
//////////////////////////// Begin pdf and read //////////////////////////////
			// Just need the css at the top and nothing else.
			return;
// ----------------- End pdf ----------------------

//////////////////////////// Begin readjs //////////////////////////////
		case 'readjs' :
			echo $jquery_jscript;
			echo $this->load->view('template/dhtmlxwindows_js_view', array(), TRUE);
			echo $math_jscripts;
			break;
// ----------------- End pdfjs ----------------------

		case 'pdfjs' :
//////////////////////////// Begin pdfjs //////////////////////////////
			echo $math_jscripts;
			echo $this->load->view('template/jscript_globalvars_view', array(), TRUE);
			return;
// ----------------- End pdfjs ----------------------

		case 'plain' :
//////////////////////////// Begin plain //////////////////////////////
			echo $jquery_jscript;
			echo $this->load->view('template/dhtmlxwindows_js_view', array(), TRUE);
			break;
// ----------------- End plain ----------------------

		case 'upload' :
			$use_plupload = TRUE;
			if ( !isset($upload_queuelist_height) || !osa_is_int($upload_queuelist_height) ) {
				$use_plupload = FALSE;
			}
			if ( !isset($tinymce) ) {
				$tinymce = FALSE;
			}
//////////////////////////// Begin upload //////////////////////////////
			if ( $use_plupload ) { ?>
<link rel="stylesheet" href="<?php echo $include_path?>js/plupload/jquery.plupload.queue/css/jquery.plupload.queue.css" type="text/css" media="screen" />
<style type="text/css">
.plupload_start, .plupload_header_content, .plupload_filelist_header {display:none}
.plupload_scroll .plupload_filelist {height:<?php echo $upload_queuelist_height;?>px}
.plupload_filelist_footer {height:20px}
li.plupload_droptext {line-height:0px}
input[type=file] {cursor:pointer}
</style>
<!--[if lte IE 8]><?php // Conditional comment with IE version detect - http://en.wikipedia.org/wiki/Conditional_comment ?>
<style type="text/css">.plupload_wrapper, .plupload_scroll .plupload_filelist {height:<?php echo $upload_queuelist_height; ?>px}</style>
<![endif]-->
<?php
			} // if ( $use_plupload )
			echo $calendar_cssfile;
			echo $home_jscritps;
			// tinymce always come before plupload
			if ( $tinymce ) {
?>
<script type="text/javascript" src="<?php echo $include_path?>js/tiny_mce/tiny_mce.js"></script>
<?php
			}
			if ( $use_plupload ) { ?>
<script type="text/javascript" src="<?php echo $include_path?>js/plupload/plupload.full.js"></script>
<script type="text/javascript" src="<?php echo $include_path?>js/plupload/jquery.plupload.queue/jquery.plupload.queue.js"></script><?php
			}
			break;
// ----------------- End upload ----------------------

		case 'home' :
		default :
//////////////////////////// Begin default/home //////////////////////////////
			echo $calendar_cssfile;
			echo $home_jscritps;
// ----------------- End default/home ----------------------
 	} // switch

 	// This is always included except if you do a return in your case statement.
 	// The globalvars view has to come after the TinyMCE math plugin else it will break.
	echo $this->load->view('template/jscript_globalvars_view', array(), TRUE);
	// Always include out own jscripts.
 	osa_appjscript_include();
?>