<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/**
 * CodeIgniter
 *
 * An open source application development framework for PHP 5.1.6 or newer
 *
 * @package		CodeIgniter
 * @author		ExpressionEngine Dev Team
 * @copyright	Copyright (c) 2008 - 2011, EllisLab, Inc.
 * @license		http://codeigniter.com/user_guide/license.html
 * @link		http://codeigniter.com
 * @since		Version 1.0
 * @filesource
 */

// ------------------------------------------------------------------------

/**
 * CodeIgniter Model Class
 *
 * @package		CodeIgniter
 * @subpackage	Libraries
 * @category	Libraries
 * @author		ExpressionEngine Dev Team
 * @link		http://codeigniter.com/user_guide/libraries/config.html
 */
class CI_Model {
/* Tillersoft Modification Begin */
	private $CI;
/* Tillersoft Modification End */
	/**
	 * Constructor
	 *
	 * @access public
	 */
	function __construct()
	{
	/* Tillersoft Modification Begin */
		$this->CI = &get_instance();
	/* Tillersoft Modification End */
		log_message('debug', "Model Class Initialized");
	}

	/**
	 * __get
	 *
	 * Allows models to access CI's loaded classes using the same
	 * syntax as controllers.
	 *
	 * @param	string
	 * @access private
	 */
	function __get($key)
	{
	/* Tillersoft Modification Begin */
		/*
		 * The CI object never changes so why does it have to be updated every time?
		 * Even if it changes, the new object would be reflected in $this->CI since it is assigned by refrence
		 * to a static var from the core controller class.
		 * We have a large complex page that makes CI call this function over 2000 times and you can actually
		 * see it was using 2% of the CPU time before the change...
		 * Due to the complexity of TODCM, the view as guest function was actually running the core
		 * controller constructor twice but we have modified it not to since this function was modified. 
		 *
		$CI =& get_instance();
		return $CI->$key;
		*/
		return $this->CI->$key;
	/* Tillersoft Modification End */
	}
}
// END Model Class

/* End of file Model.php */
/* Location: ./system/core/Model.php */